| Cantera 3.0.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
PDSS_IonsFromNeutral Class Reference
Thermodynamic Properties » Species Standard-State Thermodynamic Properties

Derived class for pressure dependent standard states of an ideal gas species. More...

`#include <PDSS_IonsFromNeutral.h>`

Inheritance diagram for PDSS_IonsFromNeutral:
[legend]

## Detailed Description

Derived class for pressure dependent standard states of an ideal gas species.

Attention
  This class currently does not have any test cases or examples. Its implementation may be incomplete, and future changes to Cantera may unexpectedly cause this class to stop working. If you use this class, please consider contributing examples or test cases. In the absence of new tests or examples, this class may be deprecated and removed in a future version of Cantera. See https://github.com/Cantera/cantera/issues/267 for additional information.

This class is for a single Ideal Gas species.

Deprecated:
  To be removed after Cantera 3.0

Definition at line 37 of file PDSS_IonsFromNeutral.h.

## Public Member Functions
| PDSS_IonsFromNeutral ()
| Default constructor.
Molar Thermodynamic Properties of the Species Standard State
double | enthalpy_RT () const override
| Return the standard state molar enthalpy divided by RT.
double | intEnergy_mole () const override
| Return the molar internal Energy in units of J kmol-1.
double | entropy_R () const override
| Return the standard state entropy divided by RT.
double | gibbs_RT () const override
| Return the molar Gibbs free energy divided by RT.
double | cp_R () const override
| Return the molar const pressure heat capacity divided by RT.
double | molarVolume () const override
| Return the molar volume at standard state.
double | density () const override
| Return the standard state density at standard state.
Properties of the Reference State of the Species in the Solution
double | gibbs_RT_ref () const override
| Return the molar Gibbs free energy divided by RT at reference pressure.
double | enthalpy_RT_ref () const override
| Return the molar enthalpy divided by RT at reference pressure.
double | entropy_R_ref () const override
| Return the molar entropy divided by R at reference pressure.
double | cp_R_ref () const override
| Return the molar heat capacity divided by R at reference pressure.
double | molarVolume_ref () const override
| Return the molar volume at reference pressure.
Mechanical Equation of State Properties
void | setState_TP (double temp, double pres) override
| Set the internal temperature and pressure.
Initialization of the Object
void | setParent (VPStandardStateTP *phase, size_t k) override
| Set the parent VPStandardStateTP object of this PDSS object.
void | setNeutralSpeciesMultiplier (const string &species, double mult)
void | setSpecialSpecies (bool special=true)
void | getParameters (AnyMap &eosNode) const override
| Store the parameters needed to reconstruct a copy of this PDSS object.
void | initThermo () override
| Initialization routine.
Public Member Functions inherited from PDSS_Nondimensional
double | enthalpy_mole () const override
| Return the molar enthalpy in units of J kmol-1.
double | entropy_mole () const override
| Return the molar entropy in units of J kmol-1 K-1.
double | gibbs_mole () const override
| Return the molar Gibbs free energy in units of J kmol-1.
double | cp_mole () const override
| Return the molar const pressure heat capacity in units of J kmol-1 K-1.
double | enthalpy_RT_ref () const override
| Return the molar enthalpy divided by RT at reference pressure.
double | entropy_R_ref () const override
| Return the molar entropy divided by R at reference pressure.
double | gibbs_RT_ref () const override
| Return the molar Gibbs free energy divided by RT at reference pressure.
double | cp_R_ref () const override
| Return the molar heat capacity divided by R at reference pressure.
double | molarVolume_ref () const override
| Return the molar volume at reference pressure.
double | enthalpy_RT () const override
| Return the standard state molar enthalpy divided by RT.
double | entropy_R () const override
| Return the standard state entropy divided by RT.
double | gibbs_RT () const override
| Return the molar Gibbs free energy divided by RT.
double | cp_R () const override
| Return the molar const pressure heat capacity divided by RT.
double | molarVolume () const override
| Return the molar volume at standard state.
double | density () const override
| Return the standard state density at standard state.
Public Member Functions inherited from PDSS
virtual void | setTemperature (double temp)
| Set the internal temperature.
virtual double | temperature () const
| Return the current stored temperature.
virtual void | setState_TR (double temp, double rho)
| Set the internal temperature and density.
virtual double | critTemperature () const
| critical temperature
virtual double | critPressure () const
| critical pressure
virtual double | critDensity () const
| critical density
virtual double | satPressure (double T)
| saturation pressure
double | molecularWeight () const
| Return the molecular weight of the species in units of kg kmol-1.
void | setMolecularWeight (double mw)
| Set the molecular weight of the species.
| PDSS ()=default
| Default Constructor.
| PDSS (const PDSS &b)=delete
PDSS & | operator= (const PDSS &b)=delete
virtual double | cv_mole () const
| Return the molar const volume heat capacity in units of J kmol-1 K-1.
virtual double | enthalpyDelp_mole () const
| Get the difference in the standard state enthalpy between the current pressure and the reference pressure, p0.
virtual double | entropyDelp_mole () const
| Get the difference in the standard state entropy between the current pressure and the reference pressure, p0.
virtual double | gibbsDelp_mole () const
| Get the difference in the standard state Gibbs free energy between the current pressure and the reference pressure, p0.
virtual double | cpDelp_mole () const
| Get the difference in standard state heat capacity between the current pressure and the reference pressure, p0.
double | refPressure () const
| Return the reference pressure for this phase.
double | minTemp () const
| return the minimum temperature
double | maxTemp () const
| return the minimum temperature
virtual double | pressure () const
| Returns the pressure (Pa)
virtual void | setPressure (double pres)
| Sets the pressure in the object.
virtual double | thermalExpansionCoeff () const
| Return the volumetric thermal expansion coefficient. Units: 1/K.
void | setReferenceThermo (shared_ptr< SpeciesThermoInterpType > stit)
| Set the SpeciesThermoInterpType object used to calculate reference state properties.
void | setParameters (const AnyMap &node)
| Set model parameters from an AnyMap phase description, for example from the `equation-of-state` field of a species definition.
virtual void | reportParams (size_t &kindex, int &type, double *const c, double &minTemp, double &maxTemp, double &refPressure) const
| This utility function reports back the type of parameterization and all of the parameters for the species, index.

## Protected Attributes
shared_ptr< ThermoPhase > | neutralMoleculePhase_
| Pointer to the Neutral Molecule ThermoPhase object.
map< string, double > | neutralSpeciesMultipliers_
size_t | numMult_ = 0
| Number of neutral molecule species that make up the stoichiometric vector for this species, in terms of calculating thermodynamic functions.
vector< size_t > | idNeutralMoleculeVec
| Vector of species indices in the neutral molecule ThermoPhase.
vector< double > | factorVec
| Stoichiometric coefficient for this species using the Neutral Molecule Species in the vector idNeutralMoleculeVec.
bool | add2RTln2_ = true
| Add 2RTln2 to the entropy and Gibbs free energies for this species.
vector< double > | tmpNM
| Vector of length equal to the number of species in the neutral molecule phase.
Protected Attributes inherited from PDSS_Nondimensional
double | m_h0_RT
| Reference state enthalpy divided by RT.
double | m_cp0_R
| Reference state heat capacity divided by R.
double | m_s0_R
| Reference state entropy divided by R.
double | m_g0_RT
| Reference state Gibbs free energy divided by RT.
double | m_V0
| Reference state molar volume (m^3/kmol)
double | m_hss_RT
| Standard state enthalpy divided by RT.
double | m_cpss_R
| Standard state heat capacity divided by R.
double | m_sss_R
| Standard state entropy divided by R.
double | m_gss_RT
| Standard state Gibbs free energy divided by RT.
double | m_Vss
| Standard State molar volume (m^3/kmol)
Protected Attributes inherited from PDSS
double | m_temp = -1.0
| Current temperature used by the PDSS object.
double | m_pres = -1.0
| State of the system - pressure.
double | m_p0 = -1.0
| Reference state pressure of the species.
double | m_minTemp = -1.0
| Minimum temperature.
double | m_maxTemp = 10000.0
| Maximum temperature.
double | m_mw = 0.0
| Molecular Weight of the species.
AnyMap | m_input
| Input data supplied via setParameters.
shared_ptr< SpeciesThermoInterpType > | m_spthermo
| Pointer to the species thermodynamic property manager.

## Constructor & Destructor Documentation

## ◆ PDSS_IonsFromNeutral()

PDSS_IonsFromNeutral | ( |  | ) |

Default constructor.

Definition at line 18 of file PDSS_IonsFromNeutral.cpp.

## Member Function Documentation

## ◆ enthalpy_RT()

double enthalpy_RT | ( |  | ) | const
| override virtual

Return the standard state molar enthalpy divided by RT.

Returns
  The dimensionless species standard state enthalpy divided at the current temperature and pressure.

Reimplemented from PDSS.

Definition at line 72 of file PDSS_IonsFromNeutral.cpp.

## ◆ intEnergy_mole()

double intEnergy_mole | ( |  | ) | const
| override virtual

Return the molar internal Energy in units of J kmol-1.

Returns
  The species standard state internal Energy in J kmol-1 at the current temperature and pressure.

Reimplemented from PDSS.

Definition at line 83 of file PDSS_IonsFromNeutral.cpp.

## ◆ entropy_R()

double entropy_R | ( |  | ) | const
| override virtual

Return the standard state entropy divided by RT.

Returns
  The species standard state entropy divided by RT at the current temperature and pressure.

Reimplemented from PDSS.

Definition at line 88 of file PDSS_IonsFromNeutral.cpp.

## ◆ gibbs_RT()

double gibbs_RT | ( |  | ) | const
| override virtual

Return the molar Gibbs free energy divided by RT.

Returns
  The species standard state Gibbs free energy divided by RT at the current temperature and pressure.

\[ \frac{\mu^o_k}{RT} = \sum_{m}{ \alpha_{m , k} \frac{\mu^o_{m}}{RT}} + ( 1 - \delta_{k,sp}) 2.0 \ln{2.0} \]

m is the neutral molecule species index. \( \alpha_{m , k} \) is the stoichiometric coefficient for the neutral molecule, m, that creates the thermodynamics for the ionic species k. A factor \( 2.0 \ln{2.0} \) is added to all ions except for the species ionic species, which in this case is the single anion species, with species index sp.

Reimplemented from PDSS.

Definition at line 102 of file PDSS_IonsFromNeutral.cpp.

## ◆ cp_R()

double cp_R | ( |  | ) | const
| override virtual

Return the molar const pressure heat capacity divided by RT.

Returns
  The species standard state Cp divided by RT at the current temperature and pressure.

Reimplemented from PDSS.

Definition at line 116 of file PDSS_IonsFromNeutral.cpp.

## ◆ molarVolume()

double molarVolume | ( |  | ) | const
| override virtual

Return the molar volume at standard state.

Returns
  The standard state molar volume at the current temperature and pressure. Units are m**3 kmol-1.

Reimplemented from PDSS.

Definition at line 127 of file PDSS_IonsFromNeutral.cpp.

## ◆ density()

double density | ( |  | ) | const
| override virtual

Return the standard state density at standard state.

Returns
  The standard state density at the current temperature and pressure. units are kg m-3

Reimplemented from PDSS.

Definition at line 138 of file PDSS_IonsFromNeutral.cpp.

## ◆ gibbs_RT_ref()

double gibbs_RT_ref | ( |  | ) | const
| override virtual

Return the molar Gibbs free energy divided by RT at reference pressure.

Returns
  The reference state Gibbs free energy at the current temperature, divided by RT.

Reimplemented from PDSS.

Definition at line 143 of file PDSS_IonsFromNeutral.cpp.

## ◆ enthalpy_RT_ref()

double enthalpy_RT_ref | ( |  | ) | const
| override virtual

Return the molar enthalpy divided by RT at reference pressure.

Returns
  The species reference state enthalpy at the current temperature, divided by RT.

Reimplemented from PDSS.

Definition at line 157 of file PDSS_IonsFromNeutral.cpp.

## ◆ entropy_R_ref()

double entropy_R_ref | ( |  | ) | const
| override virtual

Return the molar entropy divided by R at reference pressure.

Returns
  The species reference state entropy at the current temperature, divided by R.

Reimplemented from PDSS.

Definition at line 168 of file PDSS_IonsFromNeutral.cpp.

## ◆ cp_R_ref()

double cp_R_ref | ( |  | ) | const
| override virtual

Return the molar heat capacity divided by R at reference pressure.

Returns
  The species reference state heat capacity divided by R at the current temperature.

Reimplemented from PDSS.

Definition at line 182 of file PDSS_IonsFromNeutral.cpp.

## ◆ molarVolume_ref()

double molarVolume_ref | ( |  | ) | const
| override virtual

Return the molar volume at reference pressure.

Returns
  The reference state molar volume. units are m**3 kmol-1.

Reimplemented from PDSS.

Definition at line 193 of file PDSS_IonsFromNeutral.cpp.

## ◆ setState_TP()

void setState_TP | ( | double | temp,
|  | double | pres
| ) |  |
| override virtual

Set the internal temperature and pressure.

Parameters

  temp | Temperature (Kelvin)
  pres | pressure (Pascals)

Reimplemented from PDSS.

Definition at line 204 of file PDSS_IonsFromNeutral.cpp.

## ◆ setParent()

void setParent | ( | VPStandardStateTP * | phase,
|  | size_t | k
| ) |  |
| override virtual

Set the parent VPStandardStateTP object of this PDSS object.

This information is only used by certain PDSS subclasses

Parameters

  phase | Pointer to the parent phase
  k | Index of this species in the phase

Reimplemented from PDSS.

Definition at line 23 of file PDSS_IonsFromNeutral.cpp.

## ◆ setNeutralSpeciesMultiplier()

void setNeutralSpeciesMultiplier | ( | const string & | species,
|  | double | mult
| ) |  |

Definition at line 28 of file PDSS_IonsFromNeutral.cpp.

## ◆ setSpecialSpecies()

void setSpecialSpecies | ( | bool | special = `true` | ) |

Definition at line 34 of file PDSS_IonsFromNeutral.cpp.

## ◆ getParameters()

void getParameters | ( | AnyMap & | eosNode | ) | const
| override virtual

Store the parameters needed to reconstruct a copy of this PDSS object.

Reimplemented from PDSS.

Definition at line 38 of file PDSS_IonsFromNeutral.cpp.

## ◆ initThermo()

void initThermo | ( |  | ) |
| override virtual

Initialization routine.

This is a cascading call, where each level should call the the parent level.

Reimplemented from PDSS.

Definition at line 50 of file PDSS_IonsFromNeutral.cpp.

## Member Data Documentation

## ◆ neutralMoleculePhase_

shared_ptr<ThermoPhase> neutralMoleculePhase_
| protected

Pointer to the Neutral Molecule ThermoPhase object.

Definition at line 100 of file PDSS_IonsFromNeutral.h.

## ◆ neutralSpeciesMultipliers_

map<string, double> neutralSpeciesMultipliers_
| protected

Definition at line 102 of file PDSS_IonsFromNeutral.h.

## ◆ numMult_

size_t numMult_ = 0
| protected

Number of neutral molecule species that make up the stoichiometric vector for this species, in terms of calculating thermodynamic functions.

Definition at line 106 of file PDSS_IonsFromNeutral.h.

## ◆ idNeutralMoleculeVec

vector<size_t> idNeutralMoleculeVec
| protected

Vector of species indices in the neutral molecule ThermoPhase.

Definition at line 109 of file PDSS_IonsFromNeutral.h.

## ◆ factorVec

vector<double> factorVec
| protected

Stoichiometric coefficient for this species using the Neutral Molecule Species in the vector idNeutralMoleculeVec.

Definition at line 113 of file PDSS_IonsFromNeutral.h.

## ◆ add2RTln2_

bool add2RTln2_ = true
| protected

Add 2RTln2 to the entropy and Gibbs free energies for this species.

This is true if this species is not the special species

Definition at line 119 of file PDSS_IonsFromNeutral.h.

## ◆ tmpNM

vector<double> tmpNM
| mutable protected

Vector of length equal to the number of species in the neutral molecule phase.

Definition at line 122 of file PDSS_IonsFromNeutral.h.

The documentation for this class was generated from the following files:

- PDSS_IonsFromNeutral.h
- PDSS_IonsFromNeutral.cpp